/* Public domain. */

#ifndef BUFALLOC_H
#define BUFALLOC_H

#include "allreadwrite.h"
#include "gen_alloc.h"
#include "stralloc.h"

typedef struct bufalloc bufalloc, *bufalloc_ref ;

struct bufalloc
{
  int fd ;
  unsigned int p ;
  stralloc x ;
  iofunc_t_ref op ;
} ;

#define BUFALLOC_ZERO { -1, 0, GEN_ALLOC_ZERO, 0 }
#define BUFALLOC_INIT(op, fd) {(fd), 0, GEN_ALLOC_ZERO, (op)}
extern void bufalloc_init (bufalloc_ref, iofunc_t_ref, int) ;
#define bufalloc_shrink(ba) stralloc_shrink(&(ba)->x)
#define bufalloc_free(ba) stralloc_free(&(ba)->x)
#define bufalloc_put(ba, s, n) stralloc_catb(&(ba)->x, (s), (n))
extern int bufalloc_flush (bufalloc_ref) ;
extern void bufalloc_clean (bufalloc_ref) ;
#define bufalloc_len(ba) ((ba)->x.len - (ba)->p)
#define bufalloc_isempty(ba) ((ba)->x.len == (ba)->p)

extern bufalloc_ref bufalloc_1, bufalloc_2 ;

#endif
