/* Public domain. */

#ifndef DJBUNIX_H
#define DJBUNIX_H

#include "gccattributes.h"
#include "stralloc.h"
#include "env.h"        /* compatibility */

extern int coe (int) ;
extern void deepsleep (unsigned int) gccattr_const ;
extern int fd_copy (int, int) ;
extern int fd_copy2 (int, int, int, int) ;
extern int fd_move (int, int) ;
extern int fd_move2 (int, int, int, int) ;
extern int fifo_make (char const *, int) ;
extern int lock_ex (int) ;
extern int lock_exnb (int) ;
extern int lock_sh (int) ;
extern int lock_shnb (int) ;
extern int lock_un (int) ;
extern int ndelay_on (int) ;
extern int ndelay_off (int) ;
extern int open_read (char const *) ;
extern int open_excl (char const *) ;
extern int open_append (char const *) ;
extern int open_trunc (char const *) ;
extern int open_write (char const *) ;

extern int pathexec_env (char const *, char const *) ;
extern void pathexec_r (char const *const *, char const *const *, unsigned int, char const *, unsigned int) ;
extern void pathexec_fromenv (char const *const *, char const *const *, unsigned int) ;
extern void execvep (char const *, char const *const *, char const *const *, char const *) ;
extern void pathexec_run (char const *, char const *const *, char const *const *) ;
extern void pathexec0_run (char const *const *, char const *const *) ;
extern void pathexec (char const *const *) ;
extern void pathexec0 (char const *const *) ;

extern int prot_gid (int) ;
extern int prot_uid (int) ;

typedef unsigned long seek_pos ;
extern seek_pos seek_cur (int) ;
extern int seek_set (int, seek_pos) ;
extern int seek_end (int) ;
extern int seek_trunc (int, seek_pos) ;
#define seek_begin(fd) (seek_set((fd),(seek_pos) 0))

extern int wait_pid (int *, int) ;
extern int wait_nohang (int *) ;
extern int wait_pid_nohang (int *, int) ;
extern int wait_pids_nohang (int *, int const *, unsigned int) ;
extern int wait_stop (void) ;
extern int wait_stopnohang (void) ;

#define wait_crashed(w) ((w) & 127)
#define wait_exitcode(w) ((w) >> 8)
#define wait_stopsig(w) ((w) >> 8)
#define wait_stopped(w) (((w) & 127) == 127)
#define wait_status(w) (wait_crashed(w) ? 111 : wait_exitcode(w))

extern int absolutepath (stralloc *, char const *) ;
extern char *basename (char const *) gccattr_pure ;
extern int dirname (char *, char const *) ;
extern int sareadlink (stralloc *, char const *) ;

extern int doublefork (void) ;
extern unsigned int wait_reap (void) ;
extern int waitn (int const *, unsigned int) ;

extern int slurp (stralloc *, int) ;
extern int openslurpclose (stralloc *, char const *) ;
extern int readclose_append (int, stralloc *, unsigned int) ;
extern int readclose (int, stralloc *, unsigned int) ;
extern int openreadclose (char const *, stralloc *, unsigned int) ;
extern int openreadnclose (char const *, char *, unsigned int) ;

extern int rm_rf (char const *) ;
extern int rmstar (char const *) ;

#endif
