/* Public domain. */

#ifndef FMTSCAN_H
#define FMTSCAN_H

#include "gccattributes.h"

#define FMT_ULONG 40 /* enough space to hold 2^128 - 1 in decimal, plus \0 */
#define FMT_LEN ((char *) 0) /* convenient abbreviation */


extern unsigned int int_fmt (char *, int) ;
#define fmt_int int_fmt
extern unsigned int long_fmt (char *, long) ;
#define fmt_long long_fmt
extern unsigned int short_fmt (char *, short) ;
#define fmt_short short_fmt
extern unsigned int uint_fmt (char *, unsigned int) ;
#define fmt_uint uint_fmt
extern unsigned int uint0_fmt (char *, unsigned int, unsigned int) ;
#define fmt_uint0 uint0_fmt
extern unsigned int xint_fmt (char *, unsigned int) ;
#define fmt_xint xint_fmt
extern unsigned int nbbint_fmt (char *, unsigned int, unsigned int, unsigned int, unsigned int) ;
#define fmt_nbbint nbbint_fmt
extern unsigned int ushort_fmt (char *, unsigned short) ;
#define fmt_ushort ushort_fmt
extern unsigned int xshort_fmt (char *, unsigned short) ;
#define fmt_xshort xshort_fmt
extern unsigned int nbbshort_fmt (char *, unsigned int, unsigned int, unsigned int, unsigned short) ;
#define fmt_nbbshort nbbshort_fmt
extern unsigned int ulong_fmt (char *, unsigned long) ;
#define fmt_ulong ulong_fmt
extern unsigned int olong_fmt (char *, unsigned long) ;
#define fmt_olong olong_fmt
extern unsigned int xlong_fmt (char *, unsigned long) ;
#define fmt_xlong xlong_fmt
extern unsigned int nbblong_fmt (char *, unsigned int, unsigned int, unsigned int, unsigned long) ;
#define fmt_nbblong nbblong_fmt

extern unsigned int plusminus_fmt (char *, int) ;
#define fmt_plusminus plusminus_fmt
extern unsigned int minus_fmt (char *, int) ;
#define fmt_minus minus_fmt
extern unsigned int fmt_0x (char *, int) ;

extern unsigned int str_fmt (char *, char const *) ;
#define fmt_str str_fmt
extern unsigned int strn_fmt (char *, char const *, unsigned int) ;
#define fmt_strn strn_fmt
extern unsigned int ucharn_fmt (char *, unsigned char const *, unsigned int) ;
#define fmt_ucharn ucharn_fmt

extern unsigned int ip4_scan (char const *, char *) ;
extern unsigned int ip4_fmt (char *, char const *) ;
#define IP4_FMT 20

extern unsigned int ucharn_scan (char const *, unsigned char *, unsigned int) ;
#define scan_ucharn ucharn_scan
extern unsigned int int_scan (char const *, int *) ;
#define scan_int int_scan
extern unsigned int long_scan (char const *, long *) ;
#define scan_long long_scan
extern unsigned int short_scan (char const *, short *) ;
#define scan_short short_scan
extern unsigned int uint_scan (char const *, unsigned int *) ;
#define scan_uint uint_scan
extern unsigned int uint0_scan (char const *, unsigned int *) ;
#define scan_uint0 uint0_scan
extern unsigned int oint_scan (char const *, unsigned int *) ;
#define scan_oint oint_scan
extern unsigned int xint_scan (char const *, unsigned int *) ;
#define scan_xint xint_scan
extern unsigned int nbbint_scan (char const *, unsigned int, unsigned int, unsigned int, unsigned int *) ;
#define scan_nbbint nbbint_scan
extern unsigned int ushort_scan (char const *, unsigned short *) ;
#define scan_ushort ushort_scan
extern unsigned int ushort0_scan (char const *, unsigned short *) ;
#define scan_ushort0 ushort0_scan
extern unsigned int xshort_scan (char const *, unsigned short *) ;
#define scan_xshort xshort_scan
extern unsigned int nbbshort_scan (char const *, unsigned int, unsigned int, unsigned int, unsigned short *) ;
#define scan_nbbshort nbbshort_scan
extern unsigned int ulong_scan (char const *, unsigned long *) ;
#define scan_ulong ulong_scan
extern unsigned int ulong0_scan (char const *, unsigned long *) ;
#define scan_ulong0 ulong0_scan
extern unsigned int olong_scan (char const *, unsigned long *) ;
#define scan_olong olong_scan
extern unsigned int xlong_scan (char const *, unsigned long *) ;
#define scan_xlong xlong_scan
extern unsigned int nbblong_scan (char const *, unsigned int, unsigned int, unsigned int, unsigned long *) ;
#define scan_nbblong nbblong_scan

extern unsigned int plusminus_scan (char const *, int *) ;
#define scan_plusminus plusminus_scan
extern unsigned int scan_0x (char const *, unsigned int *) ;

extern unsigned int scan_whitenskip (char const *, unsigned int) gccattr_pure ;
extern unsigned int scan_nonwhitenskip (char const *, unsigned int) gccattr_pure ;
extern unsigned int scan_charsetnskip (char const *, char const *, unsigned int) gccattr_pure ;
extern unsigned int scan_noncharsetnskip (char const *, char const *, unsigned int) gccattr_pure ;

extern unsigned int scan_strncmp (char const *, char const *, unsigned int) gccattr_pure ;
extern unsigned int scan_memcmp (char const *, char const *, unsigned int) gccattr_pure ;

#define scan_8long(s, o) olong_scan((s), (o))

#endif
