/* Public domain. */

#ifndef SIG_H
#define SIG_H

extern int sig_alarm ;
extern int sig_child ;
extern int sig_stop ;
extern int sig_cont ;
extern int sig_hangup ;
extern int sig_int ;
extern int sig_kill ;
extern int sig_pipe ;
extern int sig_term ;
extern int sig_usr1 ;
extern int sig_usr2 ;
extern int sig_quit ;
extern int sig_abort ;

#define SIGSTACKSIZE 16
typedef void skasighandler_t (int) ;
typedef skasighandler_t *skasighandler_t_ref ;
extern int sig_push (int, skasighandler_t_ref) ;
extern int sig_pop (int) ;

extern skasighandler_t_ref sig_defaulthandler ;
extern skasighandler_t_ref sig_ignorehandler ;

extern void sig_catch (int, skasighandler_t_ref) ;
extern void sig_restore (int) ;
#define sig_ignore(s) sig_catch((s), sig_ignorehandler)
#define sig_uncatch(s) sig_catch((s), sig_defaulthandler)


extern void sig_block (int) ;
extern void sig_unblock (int) ;
extern void sig_blocknone (void) ;
extern void sig_pause (void) ;
extern void sig_shield (void) ;
extern void sig_unshield (void) ;

#endif
