/* Public domain. */

#ifndef UINT64_H
#define UINT64_H

typedef unsigned long long uint64 ;

#define uint64_little_endian(s, n)
#define uint64_big_endian(s, n) uint64_reverse((s), (n))

extern void uint64_pack (char *, uint64) ;
extern void uint64_pack_big (char *, uint64) ;
extern void uint64_unpack (char const *, uint64 *) ;
extern void uint64_unpack_big (char const *, uint64 *) ;
extern void uint64_reverse (char *, unsigned int) ;

#define UINT64_FMT 21
extern unsigned int uint64_fmt (char *, uint64) ;
extern unsigned int uint64_scan (char const *, uint64 *) ;
extern unsigned int uint640_scan (char const *, uint64 *) ;

#endif
